%include "nagoa+.inc"
API MessageBoxA,user32.dll
API GetModuleHandleA, kernel32.dll
API SetDlgItemTextA ,user32.dll
API GetDlgItem,user32.dll
API MessageBoxA, user32.dll
API SendDlgItemMessageA,user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API EnableWindow,user32.dll
API PostQuitMessage,user32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API GetCommandLineA,kernel32.dll
API SetFocus,user32.dll
;;API sprintf,msvcrt.dll
API DialogBoxParamA,user32.dll
%define	iobuf_size	96

segment .data USE32
ten:		db	10,0,0,0
CommandLine	dd 0

magic dd 0
hbutton dd 0
InEdit dd 0
OutEdit dd 0

Instance        	dd 0

Windowname db "PEfactor",0
FACTOR_BUTTON equ 100
LABEL1_ID equ 101
LABEL2_ID equ 102
EDIT1_ID equ 103
EDIT2_ID equ 104
ABOUT_BUTTON equ 105
LABEL3_ID equ 106
abouttext db "  PEfactor V1.02 - Factorizer",13,10,"Created using NASM win32 assembler",13,10,"                       -mathi",13,10,"      (mathiisalive@yahoo.com)",0
itm1: times 128 db 0

segment .bss USE32
factordata resb 1024
factorptr resd 1
fpubuf resb 108
MessageBuffer resb MSG_size

resb 3
factor:		resd	2		; number being tested for factorhood

buf		equ	$ - factor
		resd	3		; general-purpose numerical buffer

iobuf		equ	$ - factor
		resb	iobuf_size	; buffer for I/O

segment .code USE32
..start:
	call GetModuleHandleA, 0
	mov dword [Instance], eax
	call GetCommandLineA
	mov dword [CommandLine], eax
	call DialogBoxParamA,[Instance],1000,0,WindowProc,0
	
	call ExitProcess,eax


proc WindowProc,hwnd,uMsg,wParam,lParam
	if dword[@uMsg],e,WM_DESTROY
		call PostQuitMessage, 0	
		xor eax,eax
		jmp near returntrue
	endif
	if dword[@uMsg],e,WM_INITDIALOG
		call SendDlgItemMessageA,[@hwnd],EDIT1_ID,EM_LIMITTEXT,19,0
		call GetDlgItem,[@hwnd],EDIT2_ID
		mov [OutEdit],eax
		call GetDlgItem,[@hwnd],FACTOR_BUTTON
		mov [hbutton],eax
		call GetDlgItem,[@hwnd],EDIT1_ID
		mov [InEdit],eax
		call SetFocus,[InEdit]
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_COMMAND
		if word [@wParam],e,FACTOR_BUTTON
			call EnableWindow,[hbutton],FALSE
			call SendDlgItemMessageA,[@hwnd],EDIT1_ID,WM_GETTEXT,20,itm1			
			mov [factorptr],dword factordata
			mov esi,itm1
			mov edi,factor
			finit
			loccall Factorize,[@hwnd]
			cmp al,1
			jz near errormsg1
			mov dword[factorptr],0
			call SetDlgItemTextA,[@hwnd],EDIT2_ID,factordata
			jmp near returnback3
			errormsg1:
				call MessageBoxA,[@hwnd],"Number may be too big","PEfactor",0
				call SetDlgItemTextA,[@hwnd],EDIT2_ID,NULL
			returnback3:
			call EnableWindow,[hbutton],TRUE
			call SetFocus,[InEdit]
			jmp near returntrue
		endif				
		if word [@wParam],e,ABOUT_BUTTON
			call MessageBoxA,[@hwnd],abouttext,"PEfactor v1.02",0
			call SetFocus,[InEdit]
			jmp near returntrue
		endif
	
	endif
	if dword [@uMsg],e,WM_CLOSE
		call ExitProcess,0
		
	endif
	return FALSE
	
	returntrue:
	return TRUE
endproc

proc Factorize,ourwin1
		xor	eax, eax
		fild	dword [ten]			; 10.0
		fldz					; num  10.0
atoiloop:
		lodsb
		or	al, al
		jz	atoiloopend
		fmul	st0, st1			; n10  10.0
		sub	al, '0'
		jc	errbadnum
		cmp	al, 10
		jnc	errbadnum
		mov	[byte edi + buf], eax
		fiadd	dword [byte edi + buf]		; num  10.0
		jmp	short atoiloop
errbadnum:
		mov	al, 1
factorizereturn:
		fcompp
		jmp near returnback1 
atoiloopend:
		fld	st0				; num  num  10.0
		fstp	tword [byte edi + buf]		; num  10.0
		mov	eax, [byte edi + buf + 8]
		
		cmp	ax, 63 + 0x3FFF
		jge	errbadnum
						; num  junk
	;mov	bl, ':'
	;loccall	itoa64,[@ourwin1]
		fxch	st1				; junk num
		fld1					; 1.0  junk num
		fcom	st2
		fstsw	ax
		and	ah, 0x45
		cmp	ah, 1
		jnz	near earlyout
		fcompp					; num
		xor	edx, edx
		mov	dl, 2
		mov	[edi], edx
		
		loccall	factorconst,[@ourwin1]

		inc	dword [edi]

		loccall	factorconst,[@ourwin1]

		mov	byte [edi], 5

		loccall	factorconst,[@ourwin1]
                
		fld1					; 1.0  num
		fcom	st1
		fnstsw	ax
		and	ah, 0x40
		jnz	quitfactorize
							; junk num
		mov	byte [edi], 7
		fild	qword [edi]			; fact junk num
		fdivr	st0, st2			; quot junk num
		
		mov	dword[magic], 0x42424626		
notafactor:					
		mov	esi, [edi]		
		rol	dword[magic], 4			
		mov	eax, [magic]		
		and	eax, byte 0x0F		
		
		add	[edi], eax
		jc	earlyout

mainloop:						; quot quo0 num
		fst	st1				; quot quot num
		fstp	tword [byte edi + buf]		; quot num
		fild	qword [edi]			; fact quot num
		fdivr	st0, st2			; quo2 quot num
		mov	edx, [byte edi + buf + 4]
		mov	ecx, 31 + 0x3FFF
		sub	ecx, [byte edi + buf + 8]
		js	keepgoing
		mov	eax, edx
		shr	eax, cl
		cmp	eax, esi
		jnc	keepgoing
earlyout:	fxch	st2
		loccall	itoa64,[@ourwin1]
		fstp	st0
quitfactorize:	fcompp
		jmp near returnback1
keepgoing:	mov	eax, [byte edi + buf]
		neg	ecx
		js	shift32
		xchg	eax, edx
		xor	eax, eax
shift32:	shld	edx, eax, cl
		shl	eax, cl
		or	eax, edx
		jnz	notafactor
					; junk num  num0
		cmp	[edi], esi
		jz	repeating
		ror	dword[magic], 4
		mov	[edi], esi
repeating:	ffree	st2				; junk num
		fild	qword [edi]			; fact junk num
		loccall	itoa64,[@ourwin1]
		fdivr	st0, st2			; quot junk num
		mov	esi, [edi]
		jmp	near mainloop
returnback1:
endproc
proc factorconst,ourwin2
				; num  +
		fild	dword [edi]			; div  num  +
	factorconstloop:
		fld	st1				; num  div  num  +
		fdiv	st0, st1			; quot div  num  +
		fld	st0				; quot quot div  num  +
		frndint					; quoi quot div  num  +
		fcomp	st1				; quot div  num  +
		fnstsw	ax           
		and	ah, 0x40
		jz	near constreturn
		fstp	st2		; div  quot +
		loccall itoa64,[@ourwin2]
		jmp	short factorconstloop
constreturn:
fcompp

endproc
proc itoa64,ourwin3
	
		fld	st0				; num  num  +
		fild	dword [ten]			; 10.0 num  num  +
		lea	ecx, [byte edi + iobuf + 32]
		mov	edx, ecx
		dec	ecx
moduloloop:
		fld	st1				; num  10.0 num  num  +
		fprem					; rem  10.0 num  num  +
		fist	dword [edx]			; rem  10.0 num  num  +
		fsubr	st0, st2			; 10n2 10.0 num  num  +
		ftst
		fstsw	ax
		fstp	st2				; 10.0 10n2 num  +
		fdiv	st1, st0			; 10.0 num2 num  +
		mov	al, '0'
		add	al, [edx]
		mov	[ecx], al
		dec	ecx
		and	ah, 0x40
		jz	moduloloop
		fcompp				; num  +
prefix:
;; The string is written to standard output, and the subroutine ends.
		inc ecx
		mov byte[edx],0
		loccall displayfac,[@ourwin3]
		dec	eax
endproc

proc displayfac,ourwin4
		pusha
	;fsave [fpubuf]
		mov esi,ecx
		mov edi,dword[factorptr]
		readnextchar:
			lodsb
			cmp al,0
			jz writtenfactor
			stosb
			jmp readnextchar
		writtenfactor:
			mov al,09
			stosb
			mov byte[edi],0       ;
			;pusha
			;call MessageBoxA,[@ourwin4],factordata,"ha",0  ;
			;popa
			mov [factorptr],edi
	;frstor [fpubuf]
		popa
endproc